
package com.edunetcracker.simulator.model.element;

import com.edunetcracker.simulator.model.DBObject;
import com.edunetcracker.simulator.model.DTO.SocketMessageDTO;
import com.edunetcracker.simulator.model.context.NEContext;
import com.edunetcracker.simulator.model.Scene;
import com.edunetcracker.simulator.model.dataUnit.DataUnit;
import com.edunetcracker.simulator.model.port.RouterPort;
import com.edunetcracker.simulator.service.context.ContextService;
import com.edunetcracker.simulator.service.status.SequenceStatus;
import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import lombok.Getter;
import lombok.Setter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.persistence.*;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ConcurrentLinkedQueue;

@Setter
@Getter
@Entity
@Inheritance(strategy = InheritanceType.JOINED)
public abstract class NetworkElement extends Thread implements DBObject<NetworkElement> {

    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @JsonProperty
    private long idNE;

    @Column
    @JsonProperty
    private long x;

    @Column
    @JsonProperty
    private long y;

    @Transient
    @JsonProperty
    protected String typeName;

    @Column
    @JsonProperty("name")
    private String nameNE;


    @Column
    @JsonProperty
    private String physConfigType;

    @Transient
    @JsonProperty
    private long sceneId;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "scene_id", referencedColumnName = "id")
    private Scene scene;



//    @Transient
//    private Scene scene;
//
//
//    @JsonProperty
//    //@ManyToOne(fetch = FetchType.LAZY)
//    @JoinColumn(name = "scene_id", referencedColumnName = "id")
//    private Long sceneId;

    @Transient
    protected List<NEContext> contexts;

    @Transient
    private boolean working = true;

    @Transient
    private float loading;

    @Transient
    private float averageLoading;

    @Transient
    private int tactModRate;

    @Transient
    protected final static int inputProcessingRate = 100; //maximum amount packages per tact
    @Transient
    protected final static int statusSendingRate = 5;  //status is sending 1 tact per statusSendingRate

    @Transient
    @Deprecated
    @JsonProperty
    protected Long sessionId = 111L;

    @Transient
    protected final static int loadingRate = 100;

    //tasks from user
    @Transient
    private ConcurrentLinkedQueue   userInput;
    @Transient
    private ConcurrentLinkedQueue   userOutput;


    public NetworkElement() {
        contexts = new LinkedList<>();
        tactModRate = 0;
    }

    protected NetworkElement(int id) {
        this.idNE = id;
        tactModRate = 0;
    }

    @Override
    public void start() {
        setWorking(true);
        super.start();
    }

    @Override
    public SequenceStatus copyRefs(NetworkElement another) {
        scene = another.scene;
        userInput = another.userInput;
        userOutput = another.userOutput;
        return SequenceStatus.OK;
    }

    @Override
    public SequenceStatus copyAutogeneratedValues (NetworkElement another) {
        idNE = another.idNE;
        return SequenceStatus.OK;
    }

    @Override
    public void run() {

        Long stamp = 0L;
        tactModRate = 0;
        averageLoading = 0;
        SocketMessageDTO message = new SocketMessageDTO();

        while (working) {
             tactModRate++;
             averageLoading = averageLoading + loading;

             stamp = System.currentTimeMillis();
             
             processCommands();
             processInputTraffic();
             processContexts();

            try {
                //so that time would split into equal parts
                Thread.sleep(Math.max(0, 100 + stamp - System.currentTimeMillis()));
            } catch (InterruptedException ie) {
                Logger logger = LoggerFactory.getLogger(NetworkElement.class);
                logger.error(ie.getMessage());
            }
            if (tactModRate == statusSendingRate){
                tactModRate = 0;


                String load = Integer.toString(Math.round(averageLoading * 100 / statusSendingRate));
                averageLoading = 0;
                message.setSessionId("111");
                message.setType(SocketMessageDTO.TRAFFIC);
                message.setDataId(Long.toString(idNE));
                message.setData(load);
                message = new SocketMessageDTO("111",SocketMessageDTO.TRAFFIC,Long.toString(idNE),load);
                this.send(message);

            }
        }

    }



    protected void send(SocketMessageDTO message){
    }

    protected abstract void processContexts();

    protected abstract void processInputTraffic();

    protected abstract void processCommands();

    protected void evaluateLoading (int processedDUnitsNumber) {
        setLoading((float)processedDUnitsNumber/(float)inputProcessingRate);
    }

    @Override
    public String toString() {
        ObjectMapper mapper = new ObjectMapper();
        mapper.setVisibilityChecker(mapper.getDeserializationConfig().getDefaultVisibilityChecker()
                .withCreatorVisibility(JsonAutoDetect.Visibility.NONE)
                .withFieldVisibility(JsonAutoDetect.Visibility.NONE)
                .withGetterVisibility(JsonAutoDetect.Visibility.NONE)
                .withIsGetterVisibility(JsonAutoDetect.Visibility.NONE)
                .withSetterVisibility(JsonAutoDetect.Visibility.NONE));
        String result = null;
        try {
            result = mapper.writeValueAsString(this);
        } catch (JsonProcessingException e) {
            e.printStackTrace();
        }
        return result;
    }

}


